# Generated by Django 3.2.19 on 2023-06-07 07:59

import core.fields
import datetime
import dirtyfields.dirtyfields
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import simple_history.models


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('individual', '0004_add_group_rights_to_admin'),
        ('social_protection', '0004_add_beneficiary_rights_to_admin'),
    ]

    operations = [
        migrations.AddField(
            model_name='benefitplan',
            name='type',
            field=models.CharField(choices=[('INDIVIDUAL', 'INDIVIDUAL'), ('GROUP', 'GROUP')], default='INDIVIDUAL', max_length=100),
        ),
        migrations.AddField(
            model_name='historicalbenefitplan',
            name='type',
            field=models.CharField(choices=[('INDIVIDUAL', 'INDIVIDUAL'), ('GROUP', 'GROUP')], default='INDIVIDUAL', max_length=100),
        ),
        migrations.AlterField(
            model_name='beneficiary',
            name='status',
            field=models.CharField(choices=[('POTENTIAL', 'POTENTIAL'), ('ACTIVE', 'ACTIVE'), ('GRADUATED', 'GRADUATED'), ('SUSPENDED', 'SUSPENDED')], max_length=100),
        ),
        migrations.AlterField(
            model_name='historicalbeneficiary',
            name='status',
            field=models.CharField(choices=[('POTENTIAL', 'POTENTIAL'), ('ACTIVE', 'ACTIVE'), ('GRADUATED', 'GRADUATED'), ('SUSPENDED', 'SUSPENDED')], max_length=100),
        ),
        migrations.CreateModel(
            name='HistoricalGroupBeneficiary',
            fields=[
                ('id', models.UUIDField(db_column='UUID', db_index=True, default=None, editable=False)),
                ('is_deleted', models.BooleanField(db_column='isDeleted', default=False)),
                ('json_ext', models.JSONField(blank=True, db_column='Json_ext', null=True)),
                ('date_created', core.fields.DateTimeField(db_column='DateCreated', null=True)),
                ('date_updated', core.fields.DateTimeField(db_column='DateUpdated', null=True)),
                ('version', models.IntegerField(default=1)),
                ('date_valid_from', core.fields.DateTimeField(db_column='DateValidFrom', default=datetime.datetime.now)),
                ('date_valid_to', core.fields.DateTimeField(blank=True, db_column='DateValidTo', null=True)),
                ('replacement_uuid', models.UUIDField(db_column='ReplacementUUID', null=True)),
                ('status', models.CharField(choices=[('POTENTIAL', 'POTENTIAL'), ('ACTIVE', 'ACTIVE'), ('GRADUATED', 'GRADUATED'), ('SUSPENDED', 'SUSPENDED')], max_length=100)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField(db_index=True)),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('benefit_plan', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='social_protection.benefitplan')),
                ('group', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='individual.group')),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('user_created', models.ForeignKey(blank=True, db_column='UserCreatedUUID', db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('user_updated', models.ForeignKey(blank=True, db_column='UserUpdatedUUID', db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'historical group beneficiary',
                'verbose_name_plural': 'historical group beneficiarys',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': ('history_date', 'history_id'),
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='GroupBeneficiary',
            fields=[
                ('id', models.UUIDField(db_column='UUID', default=None, editable=False, primary_key=True, serialize=False)),
                ('is_deleted', models.BooleanField(db_column='isDeleted', default=False)),
                ('json_ext', models.JSONField(blank=True, db_column='Json_ext', null=True)),
                ('date_created', core.fields.DateTimeField(db_column='DateCreated', null=True)),
                ('date_updated', core.fields.DateTimeField(db_column='DateUpdated', null=True)),
                ('version', models.IntegerField(default=1)),
                ('date_valid_from', core.fields.DateTimeField(db_column='DateValidFrom', default=datetime.datetime.now)),
                ('date_valid_to', core.fields.DateTimeField(blank=True, db_column='DateValidTo', null=True)),
                ('replacement_uuid', models.UUIDField(db_column='ReplacementUUID', null=True)),
                ('status', models.CharField(choices=[('POTENTIAL', 'POTENTIAL'), ('ACTIVE', 'ACTIVE'), ('GRADUATED', 'GRADUATED'), ('SUSPENDED', 'SUSPENDED')], max_length=100)),
                ('benefit_plan', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to='social_protection.benefitplan')),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to='individual.group')),
                ('user_created', models.ForeignKey(db_column='UserCreatedUUID', on_delete=django.db.models.deletion.DO_NOTHING, related_name='groupbeneficiary_user_created', to=settings.AUTH_USER_MODEL)),
                ('user_updated', models.ForeignKey(db_column='UserUpdatedUUID', on_delete=django.db.models.deletion.DO_NOTHING, related_name='groupbeneficiary_user_updated', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
    ]
